# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/cloud/dialogflow/v2/participant.proto for package 'google.cloud.dialogflow.v2'
# Original file comments:
# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/cloud/dialogflow/v2/participant_pb'

module Google
  module Cloud
    module Dialogflow
      module V2
        module Participants
          # Service for managing [Participants][google.cloud.dialogflow.v2.Participant].
          class Service

            include ::GRPC::GenericService

            self.marshal_class_method = :encode
            self.unmarshal_class_method = :decode
            self.service_name = 'google.cloud.dialogflow.v2.Participants'

            # Creates a new participant in a conversation.
            rpc :CreateParticipant, ::Google::Cloud::Dialogflow::V2::CreateParticipantRequest, ::Google::Cloud::Dialogflow::V2::Participant
            # Retrieves a conversation participant.
            rpc :GetParticipant, ::Google::Cloud::Dialogflow::V2::GetParticipantRequest, ::Google::Cloud::Dialogflow::V2::Participant
            # Returns the list of all participants in the specified conversation.
            rpc :ListParticipants, ::Google::Cloud::Dialogflow::V2::ListParticipantsRequest, ::Google::Cloud::Dialogflow::V2::ListParticipantsResponse
            # Updates the specified participant.
            rpc :UpdateParticipant, ::Google::Cloud::Dialogflow::V2::UpdateParticipantRequest, ::Google::Cloud::Dialogflow::V2::Participant
            # Adds a text (chat, for example), or audio (phone recording, for example)
            # message from a participant into the conversation.
            #
            # Note: Always use agent versions for production traffic
            # sent to virtual agents. See [Versions and
            # environments](https://cloud.google.com/dialogflow/es/docs/agents-versions).
            rpc :AnalyzeContent, ::Google::Cloud::Dialogflow::V2::AnalyzeContentRequest, ::Google::Cloud::Dialogflow::V2::AnalyzeContentResponse
            # Gets suggested articles for a participant based on specific historical
            # messages.
            rpc :SuggestArticles, ::Google::Cloud::Dialogflow::V2::SuggestArticlesRequest, ::Google::Cloud::Dialogflow::V2::SuggestArticlesResponse
            # Gets suggested faq answers for a participant based on specific historical
            # messages.
            rpc :SuggestFaqAnswers, ::Google::Cloud::Dialogflow::V2::SuggestFaqAnswersRequest, ::Google::Cloud::Dialogflow::V2::SuggestFaqAnswersResponse
          end

          Stub = Service.rpc_stub_class
        end
      end
    end
  end
end
