# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/cloud/dialogflow/v2/session_entity_type.proto for package 'google.cloud.dialogflow.v2'
# Original file comments:
# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/cloud/dialogflow/v2/session_entity_type_pb'

module Google
  module Cloud
    module Dialogflow
      module V2
        module SessionEntityTypes
          # Service for managing [SessionEntityTypes][google.cloud.dialogflow.v2.SessionEntityType].
          class Service

            include ::GRPC::GenericService

            self.marshal_class_method = :encode
            self.unmarshal_class_method = :decode
            self.service_name = 'google.cloud.dialogflow.v2.SessionEntityTypes'

            # Returns the list of all session entity types in the specified session.
            #
            # This method doesn't work with Google Assistant integration.
            # Contact Dialogflow support if you need to use session entities
            # with Google Assistant integration.
            rpc :ListSessionEntityTypes, ::Google::Cloud::Dialogflow::V2::ListSessionEntityTypesRequest, ::Google::Cloud::Dialogflow::V2::ListSessionEntityTypesResponse
            # Retrieves the specified session entity type.
            #
            # This method doesn't work with Google Assistant integration.
            # Contact Dialogflow support if you need to use session entities
            # with Google Assistant integration.
            rpc :GetSessionEntityType, ::Google::Cloud::Dialogflow::V2::GetSessionEntityTypeRequest, ::Google::Cloud::Dialogflow::V2::SessionEntityType
            # Creates a session entity type.
            #
            # If the specified session entity type already exists, overrides the session
            # entity type.
            #
            # This method doesn't work with Google Assistant integration.
            # Contact Dialogflow support if you need to use session entities
            # with Google Assistant integration.
            rpc :CreateSessionEntityType, ::Google::Cloud::Dialogflow::V2::CreateSessionEntityTypeRequest, ::Google::Cloud::Dialogflow::V2::SessionEntityType
            # Updates the specified session entity type.
            #
            # This method doesn't work with Google Assistant integration.
            # Contact Dialogflow support if you need to use session entities
            # with Google Assistant integration.
            rpc :UpdateSessionEntityType, ::Google::Cloud::Dialogflow::V2::UpdateSessionEntityTypeRequest, ::Google::Cloud::Dialogflow::V2::SessionEntityType
            # Deletes the specified session entity type.
            #
            # This method doesn't work with Google Assistant integration.
            # Contact Dialogflow support if you need to use session entities
            # with Google Assistant integration.
            rpc :DeleteSessionEntityType, ::Google::Cloud::Dialogflow::V2::DeleteSessionEntityTypeRequest, ::Google::Protobuf::Empty
          end

          Stub = Service.rpc_stub_class
        end
      end
    end
  end
end
